<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta http-equiv="X-UA-Compatible" content="ie=edge">
  <title>Adversarial Search Methods</title>
  <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css"
    integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
  <link href="https://fonts.googleapis.com/css?family=Crimson+Text:400,700&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="css/styling.min.css" />
</head>

<body>
  <h1>Adversarial Search Methods</h1>
  <div class="content">
    <img class="header-icon" src="assets/problem.svg" />
    <p>
      Search methods are a form of Artificial Intelligence. AI is understood as the technique to use computers to mimic
      human behaviour. Search methods are part of the cognitive simulation approach of AI as they simulate human
      cognitive abilities (e.g. problem-solving, object recognition). Generally, search methods are used to find the
      optimal solution to a problem. This is done by defining different states of the problem and then transitioning
      through the states to find the optimal solution. The main idea of adversarial search methods is to use search
      methods to play games. However, these methods can be used for any scenario where two opposite sides have to be
      evaluated (e.g. negotiations).
    </p>
    <p>
      As part of my master studies, I looked at different adversarial search methods for two-player games. I implemented
      four different algorithms that can be applied to either a game of Tic Tac Toe or Connect Four. Using these
      algorithms, I conducted different experiments to gain a better understanding of their strength and weaknesses.
      This web application can be used to view my test results and to conduct your experiments. Please note that I only
      provide a brief description of the boards and algorithms.
    </p>
    <p>

      Finally, I want to point out that all calculations are done on the client (your computer). Depending on the
      computer you use and the experiment you conduct, the simulation may take a long time, and your browser might
      become unresponsive.
    </p>
    <div class="boards">
      <h2>Boards</h2>
      <div class="card-wrapper">
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Tic Tac Toe</h5>
            <p class="card-text">A board with 3x3 fields, where any player can access every empty field at any time. The
              game is won by the player who has three connected fields vertically, horizontally or diagonally.<br /><br />The depth (number of simulated moves) is set to the maximum of the number of available fields.</p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Connect Four</h5>
            <p class="card-text">A board with 7x6 fields, where players can only access fields if the field below is
              already occupied by any other player (this excludes the first row). The game is won by the player who has
              four connected fields vertically, horizontally or diagonally.<br /><br />The depth (number of simulated moves) is set to 4.</p>
          </div>
        </div>
      </div>
    </div>
    <div class="algorithms">
      <h2>Algorithms</h2>
      <div class="card-wrapper">
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Random</h5>
            <p class="card-text">This algorithm simply picks a random, accessible field.</p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Minimax</h5>
            <p class="card-text">The minimax method utilises a score that one player tries to minimise while the other
              aims to maximise it. If a player uses the minimax method, it looks at the next n moves and all possible
              game
              states S after each move. It assumes that the opponent tries to minimise the score and then makes the move
              that should result in the overall highest score after all n moves. <br /><br />
              For Tic Tac Toe the number of next
              moves
              is the number of available fields. For Connect Four, the number of next moves is limited to a maximum of
              three. Due to the broad set of possibilities to evaluate this algorithm may take a long time.</p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Alpha Beta Pruning</h5>
            <p class="card-text">This algorithm is an optimisation of the minimax method. Rather than looking at all
              possible game states the algorithm ignores certain game states, that have no chances of being selected.
              This
              is done by keeping track of already visited nodes (possible moves).<br /><br /> Even though this method does not
              evaluate as many game states as the minimax method, it may still take a long time to process.
            </p>
          </div>
        </div>
        <div class="card" style="width: 18rem;">
          <div class="card-body">
            <h5 class="card-title">Genetic Minimax</h5>
            <p class="card-text">In games, time is usually a constraining factor that might not allow for the use of the
              minimax or alpha-beta pruning algorithm. For complex problems with a large set of possible solutions, it
              is
              sometimes better to make random decisions instead of evaluating all possible nodes. Genetic (or
              evolutionary) algorithms make use of that. They start with a random set of solutions and evolve this
              population over n generations. <br /><br />The genetic minimax method does that and evaluates the population using the
              central concept of the minimax algorithm. While it may not always find the best solution, it may find a
              near
              best solution in a shorter period.</p>
          </div>
        </div>
      </div>
    </div>
    <div class="modes">
      <h2>Select Mode</h2>
      <div class="card-wrapper">
        <a href="single-game.html" target="_blank">
          <div class="card" style="width: 18rem; border-color: #FCBF49;">
            <div class="card-body">
              <h5 class="card-title">Simulate Single Game</h5>
              <p class="card-text">Simulate a single game by choosing a board and two algorithms. You can then see the
                move of each player on the board.</p>
            </div>
          </div>
        </a>
        <a href="multiple-games.html" target="_blank">
          <div class="card" style="width: 18rem; border-color: #2274A5;">
            <div class="card-body">
              <h5 class="card-title">Simulate Multiple Games</h5>
              <p class="card-text">Simulate several games by choosing a board and two algorithms. After the simulation
                completes, you will get statistics.</p>
            </div>
          </div>
        </a>
       <!-- <a href="test-results.html" target="_blank">
          <div class="card" style="width: 18rem; border-color: #32936F;">
            <div class="card-body">
              <h5 class="card-title">View Test Results</h5>
              <p class="card-text">View the results of my experiments where I simulated each combination of algorithms
                for
                Tic Tac Toe, as well as Connect Four.
              </p>
            </div>
          </div>
        </a>-->
      </div>
    </div>
  </div>
</body>

</html>